<script lang="ts">
	import { formatDateShort } from '$lib';
	import type { Thread } from '$lib/types';

	export let courseId: number, thread: Thread, selected: boolean;
</script>

<a href="/class/{courseId}/post/{thread.id}" class={selected ? 'selected' : ''}>
	<md-ripple></md-ripple>
	<div>
		<h3 class={thread.unread ? 'unread' : 'read'}>
			{thread.subject}
		</h3>
		<p class={thread.unread ? 'unread' : 'read'}>
			{thread.replies?.at(0)?.content}
		</p>
	</div>
	<div class="stats">
		{formatDateShort(thread.date)}
		<div class="badges">
			{#if thread.unread > 0}
				<div class="unread-counter">
					{thread.unread}
				</div>
			{/if}
			{#if thread.resolved}
				<div class="resolved">
					<md-icon>check</md-icon>
				</div>
			{:else}
				<div class="unresolved">
					<md-icon>question_mark</md-icon>
				</div>
			{/if}
		</div>
	</div>
</a>

<style>
	a {
		position: relative;
		display: block;
		text-decoration: none;
		padding: 1em;
		display: flex;
		color: inherit;
		border-radius: 1em;

		&.selected::after {
			content: '';
			background: var(--md-sys-color-on-surface);
			opacity: 0.1;
			border-radius: 1em;
			height: 100%;
			width: 100%;
			position: absolute;
			top: 0;
			left: 0;
		}

		& h3 {
			margin: 0;

			&.read {
				font-weight: normal;
			}
		}

		& p {
			margin: 0;
			display: -webkit-box;
			-webkit-box-orient: vertical;
			opacity: 1;
			-webkit-line-clamp: 2;
			overflow: hidden;
			font-weight: bold;

			&.read {
				font-weight: normal;
				opacity: 0.7;
			}
		}

		& .stats {
			white-space: nowrap;
			display: flex;
			flex-direction: column;
			justify-content: space-between;

			& .unread-counter {
				display: flex;
				align-items: center;
				justify-content: center;
				background: var(--md-sys-color-primary);
				color: var(--md-sys-color-on-primary);
				height: 1.5em;
				width: 1.5em;
				border-radius: 4px;
				text-align: center;
			}

			& .badges {
				display: flex;
				justify-content: end;
				gap: 4px;
				align-items: center;
			}

			& .resolved,
			.unresolved {
				display: flex;
				align-items: center;
				--md-icon-size: 20px;
			}

			& .unresolved {
				background: var(--md-sys-color-error);
				color: var(--md-sys-color-on-error);
				border-radius: 50%;
				padding: 2px;
			}

			& .resolved {
				background: #12b886;
				color: var(--md-sys-color-on-error);
				border-radius: 50%;
				padding: 2px;
			}
		}
	}
</style>
